/**
 * \file
 *
 * \brief ʂɎgpݸٰށA^Aϸ
 *
 * 쌠 (c) 2009-2012 Atmel Corporation S\ς݁B
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef UTILS_COMPILER_H
#define UTILS_COMPILER_H

#if defined(__GNUC__)
  #include <avr/io.h>
#elif defined(__ICCAVR__)
  #include <ioavr.h>
  #include <intrinsics.h>
#else
  #error "Unsupported compiler."
#endif

#include <stdbool.h>
#include <stdint.h>
#include <stddef.h>
#include <stdlib.h>

#include <parts.h>

#ifdef __ICCAVR__
/*! \name ߲ ܰ
 *
 * GCCIAR Embedded Workbenchւ̷ܰނ̈ړ]
 */
//! @{
#define __asm__				asm
#define __inline__			inline
#define __volatile__
//! @}
#endif

/**
 * \def UNUSED
 * \brief gpҰ܂͒lƂ\a vt
 */
#define UNUSED(v)			(void)(v)

/**
 * \def unused
 * \brief gpҰ܂͒lƂ\a vt
 */
#define unused(v)			do { (void)(v); } while(0)

/**
 * \def barrier
 * \brief ؏
 */
#ifdef __GNUC__
  #define barrier()			asm volatile("" ::: "memory")
#else
  #define barrier()			asm ("")
#endif

//_____ ϸ ________________________________________________________________

/**
 * \def __always_inline
 * \brief ̊֐͏ɲײ݂ɂׂłB
 *
 * ̒߂ͺׂ߲ɂ̲ײݔI@𖳎悤ɖAႦꂪ@
 * ɑ傫ȂƎvĂ֐ײ݂ɂ܂B
 */
#if (defined __GNUC__)
  #define __always_inline	inline __attribute__((__always_inline__))
#elif (defined __ICCAVR__)
  #define __always_inline	_Pragma("inline=forced")
#endif

/*! \brief ϸۂ͒vIȈُ̌Ɏgp܂B
 *
 * ϸۂ͎vI܂BȂ΁AvIُ킪oAp͒
 * ~܂BTEST_SUITE_DEFINE_ASSERT_MACRO`Ă΁ǍōX
 * Ȃ錟̎s߂ɁAϸۂ̒Pʌłgp܂B
 *
 * \param expr ]Ĕ0ƍl鎮
 */
#if defined(_ASSERT_ENABLE_)
  #if defined(TEST_SUITE_DEFINE_ASSERT_MACRO)
	// Assert()unit_test/suite.hŒ`܂B
	#include "unit_test/suite.h"
  #else
	#define Assert(expr) \
	{\
		if (!(expr)) while (true);\
	}
  #endif
#else
  #define Assert(expr) ((void) 0)
#endif

/*! \name MCUިݏ
 */
//! @{
#define MSB(u16)			(((uint8_t* )&u16)[1])
#define LSB(u16)			(((uint8_t* )&u16)[0])
//! @}

#include "interrupt.h"

#endif // UTILS_COMPILER_H
